from jira.client import JIRA
import datetime
import getpass

def main():
    #getting credentials
    print("Hello! Log in to Altoros's JIRA to update your due dates.")
    name = input("Username:")
    password = getpass.getpass("Password:")
    username = str("""'""" + name + """'""")
    print("Checking for overdue tasks...")

    #authenticating
    jira_options={'server': 'http://atlassian.altoros.com/jira'}
    jira=JIRA(options=jira_options,basic_auth=(str(name),str(password)))

    #retrieving issues
    issues = jira.search_issues("""assignee in (""" + username + """) AND resolution = Unresolved AND status!=resolved AND (duedate < now() OR duedate = null) order by due asc, priority desc""")

    #calculating the new duedate
    today = datetime.date.today()
    difference = datetime.timedelta(days=7)
    new_duedate = today + difference

    #updating overdue tasks
    if not issues:
        print("All your tasks are up to date!")
    else:
        print("The following tasks are overdue:")
        for item in issues:
            issue = jira.issue(str(item))
            issue.update(duedate=str(new_duedate))
            issue_name = issue.fields.summary
            check_new_duedate = issue.fields.duedate
            print(str(item) + " " + issue_name)
            print("http://atlassian.altoros.com/jira/browse/" + str(item))
            print("Updating the due date...")
            print("The_new_due date for " + str(item) + " is " + check_new_duedate)
        print("Congratulations! All your due dates have been successfully updated.")
